root@sharedrive:~# cat netuserupdatehome.sh
#!/bin/bash

# updated by WIBOON 2556-04-18

exitusage() 
{
  echo "usage: sudo sh $0 username"
  echo "this is use for upgrade user home from old version installed before"
  echo "2556-04-17"
  exit 
}

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi
if [ "$1" = "--help" ] ; then
  exitusage
fi
if [ -z "$1" ] ; then
  echo "need username"
  exitusage 
fi
if [ -z "$(getent passwd $1)" ] ; then
  echo "username does not exist"
  exit
fi

MYUSER=$1
HOME_DIR="/sftp/home"
HOME_WWW_RESTRICT="/var/www/noname"
HOME_WWW_PUBLIC="/var/www/ishare"
README_FILE="DO_NOT_UPLOAD_HERE.txt"
FOLDER_PRIVATE="private"
FOLDER_RESTRICT="noname"
FOLDER_PUBLIC="ishare"

echo "(1/2) Setting file and group permission."
sudo mkdir -m 770 ${HOME_DIR}/${MYUSER}/${FOLDER_PRIVATE}
find /sftp/home/${MYUSER} -maxdepth 1 ! -name ".*" ! -name "*private" ! -path "/sftp/home/${MYUSER}" -exec mv {} ${HOME_DIR}/${MYUSER}/${FOLDER_PRIVATE} \;
sudo mkdir -m 771 ${HOME_DIR}/${MYUSER}/${FOLDER_RESTRICT}
sudo mkdir -m 775 ${HOME_DIR}/${MYUSER}/${FOLDER_PUBLIC}
sudo chmod 555 ${HOME_DIR}/${MYUSER}
sudo chown -R ${MYUSER}:${MYUSER} ${HOME_DIR}/${MYUSER}/*
sudo chown -R ${MYUSER}:${MYUSER} ${HOME_DIR}/${MYUSER}/${FOLDER_RESTRICT}

echo "(2/2) Linking file from home to www directory."
sudo ln -s ${HOME_DIR}/${MYUSER}/${FOLDER_RESTRICT} ${HOME_WWW_RESTRICT}/${MYUSER}
sudo ln -s ${HOME_DIR}/${MYUSER}/${FOLDER_PUBLIC} ${HOME_WWW_PUBLIC}/${MYUSER}
sudo ln ${HOME_DIR}/${README_FILE} ${HOME_DIR}/${MYUSER}/

echo ""
echo "User ${MYUSER} home directory was updated successfully."
echo ""

